## eternalforest-by-soulman 1.0

=== Makefile ===

CC = clang
CFLAGS = -fno-plt -fno-unwind-tables -Wall -Werror -Oz
CFLAGS += $(shell pkg-config --cflags gtk+-3.0)

LIBS = -lGL -lgtk-3 -lgdk-3 -lgobject-2.0
DEBUG_LIBS = -lGL $(shell pkg-config --libs gtk+-3.0)

XZ = xz -c -9e --format=lzma --lzma1=preset=9,lc=0,lp=0,pb=0
SSTRIP = ./ELFkickers/bin/sstrip
SHADER_MINIFIER = ./Shader_Minifier/shader_minifier.exe

EXE = bin/main-4k
DEBUG_EXE = bin/main-debug

all: $(EXE)

run: $(EXE)
	./$(EXE)

debug: $(DEBUG_EXE)
	./$(DEBUG_EXE)

clean:
	rm -rf bin/ obj/ gen/

$(SSTRIP):
	cd ELFkickers; make

$(SHADER_MINIFIER):
	cd Shader_Minifier; TERM=xterm ./compile.bash

gen/%.glsl: %.glsl
	@mkdir -p gen
	unifdef -x2 -DNDEBUG -o $@ $<

gen/shaders.h: gen/fshader.glsl $(SHADER_MINIFIER)
	@mkdir -p gen
	TERM=xterm mono $(SHADER_MINIFIER) --preserve-externals $< -o $@

obj/%.o: %.c gen/shaders.h
	@mkdir -p obj
	$(CC) -c $(CFLAGS) -o $@ $<

obj/%-debug.o: %.c
	@mkdir -p obj
	$(CC) -c $(CFLAGS) -DDEBUG -o $@ $<

bin/%: obj/%.o $(SSTRIP)
	@mkdir -p bin
	#$(CC) -o $@ $^ $(LIBS)
	ld \
		-z norelro \
		-z nodelete \
		-z noseparate-code \
		-O1 \
		--orphan-handling=discard \
		--as-needed \
		--no-demangle \
		--gc-sections \
		--hash-style=gnu \
		--no-eh-frame-hdr \
		--no-ld-generated-unwind-info \
		-m elf_x86_64 \
		-dynamic-linker \
		/lib64/ld-linux-x86-64.so.2 \
		-o $@ \
		$< \
		$(LIBS)
	$(SSTRIP) $@

bin/%-debug: obj/%-debug.o
	@mkdir -p bin
	$(CC) -o $@ $^ $(DEBUG_LIBS)

%.xz: %
	cat $^ | $(XZ) > $@

%-4k: uncompress-header %.xz
	cat $^ > $@
	chmod a+x $@
	@stat --printf="$@: %s bytes\n" $@

=== debian/changelog ===
eternalforest-by-soulman (1.0-0ddebs1~debian13) trixie; urgency=medium

  * Initial release.

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Sat, 20 Dec 2025 01:29:32 +0100

=== debian/control ===
Source: eternalforest-by-soulman
Section: demos
Priority: optional
Maintainer: Nicolas HOUDELOT <nicolas@demosdebs.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 shader-minifier:native,
 unifdef:native,
 libgtk-3-dev,
 libgles-dev,
 pkgconf,
 dh-exec (>=0.3)
Standards-Version: 4.6.2
Homepage: https://github.com/knutae/solskogen-2020

Package: eternalforest-by-soulman
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 common-install-function-ddebs(>=1.61),
Description: 4k procedural gfx by Soulman, released in 2020
 Raymarched forest written in GLSL and C.
 5th at 4k executable graphics compo for the Solskogen 2020 demoparty.

=== debian/rules ===
#!/usr/bin/make -f

export PKG_CONFIG_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- debug
